<template>
  <a-form :model="actModel" :label-col="labelCol" :wrapper-col="wrapperCol">
    <a-row :gutter="24">
          <a-col :lg="18">
              <a-row :gutter="24">
                  <a-col>
                      <a-form-item label="问题项">
                          <JInput placeholder="请输入" v-model:value="actModel.problemItem"></JInput>
                      </a-form-item>
                  </a-col>
              </a-row>
              <a-row :gutter="24">
                  <a-col>
                      <a-form-item label="问题示例">
                          <JInput placeholder="请输入" v-model:value="actModel.problemExample" ></JInput>
                      </a-form-item>
                  </a-col>
              </a-row>
          </a-col>
          <a-col :span="6">
              <a-button style="width: 80%;height: 80%;line-height: 50%;" type="primary" @click="searchQuery">查询</a-button>
          </a-col>
          <!--<a-col :span="3">
            <a-button style="width: 100%;height: 80%;line-height: 50%;" type="primary" @click="handleAdd"> 新建</a-button>
          </a-col>-->
      </a-row>
      <a-row :gutter="24">
          <a-col :span="24" :pull="1">
              <a-form-item label="查询结果">
                <BasicTable @register="registerTable" :rowSelection="rowSelection" @selection-change="handlerRowClick">
                    <!-- update-begin-author:taoyan date:2022-5-25 for: VUEN-1112一对多 用户选择 未显示选择条数，及清空 -->
                    <template #tableTitle></template>
                    <!-- update-end-author:taoyan date:2022-5-25 for: VUEN-1112一对多 用户选择 未显示选择条数，及清空 -->
                </BasicTable>
                    <!--改为table实现-->
                  <!--<a-list size="small" bordered :data-source="resultData" :pagination="pagination" style="height:200px;overflow-x: auto;">
                      <template #renderItem="{ item }">
                          <a-list-item>
                              <a-row :gutter="24" style="width:100%">
                                  <a-col :span="4"><a-button type="link">{{ item.caNo }}</a-button></a-col>
                                  <a-col :span="18"><a-button type="text">{{ item.caName }}</a-button></a-col>
                                  <a-col :span="2">
                                    <a-button type="text">
                                      <a-checkbox v-model:checked="checkBox[item.caNo]" @change="handlerChecked(item)"></a-checkbox>
                                    </a-button>
                                  </a-col>
                              </a-row>
                          </a-list-item>
                      </template>
                  </a-list>-->
              </a-form-item>
          </a-col>
      </a-row>
      <!--<StCaMainModal @register="registerModal" @success="handleSuccess"></StCaMainModal>-->
  </a-form>
</template>
<script setup>
import { reactive, ref, toRaw } from 'vue';
import { JInput } from '/@/components/Form';
import { BasicTable } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { list } from '/@/views/standardlib/problem/StProblem.api.ts';
//import StCaMainModal from '/@/views/standardlib/controlactivity/components/StCaMainModal.vue';
//const [registerModal, {openModal}] = useModal();
const emit = defineEmits(['select']);
const props = defineProps({
  actinfo: Map,
});
const columns = [
   {
    title: '问题项',
    align:"left",
    dataIndex: 'problemItem'
   },
   {
    title: '问题示例',
    align:"left",
    dataIndex: 'problemExample'
   },
];
const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '问题',
           api: list,
           columns,
           canResize:false,
           useSearchForm: false,
           scroll: { x: false },
           actionColumn: {ifShow: false},
           clickToRowSelect: true,
           rowSelection: { 
                hideSelectAll: true,
                onSelect: handlerChecked,
                onChange: handlerChange,
            },
        //    actionColumn: {
        //        width: 160
        //     },
            showTableSetting: false,
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'updatedTime', order: 'desc',complianeNoIsNull:true})
            },
      },
  })
  const [registerTable, {setProps,reload},{ rowSelection, selectedRowKeys }] = tableContext
//   function handleAdd() {
//     openModal(true, {
//         isUpdate: false,
//         showFooter: true,
//     });
//   }
//   function handleSuccess() {
//     reload();
//   }
  //const checkBox = ref({})
  function handlerChange(selectedRowKeys, selectedRows){
    //console.log(selectedRowKeys)
    if(selectedRowKeys.length==0){
        Object.assign(props.actinfo,{id:'',caNo:'',caName:''})
        emit('select',false)
    }else{
        emit('select',true)  
    }
  }
  function handlerChecked(record, selected, selectedRows, nativeEvent){
    // console.log(record)
    // console.log(selected)
    // console.log(selectedRows)
    // console.log(nativeEvent)
    if(selected){
        selectedRowKeys.value = [record.id]
        Object.assign(props.actinfo,record)
        emit('select',true)
    }else{
        Object.assign(props.actinfo,{id:'',caNo:'',caName:''})
        emit('select',false)
    }
  }
  function handlerRowClick({keys,rows}){
    if(keys.length>1){
        let index = keys.length -1
        selectedRowKeys.value = [rows[index].id]
        Object.assign(props.actinfo,rows[index])
    }else{
        Object.assign(props.actinfo,rows[0])
    }
  }
const actModel = ref({
    caNo: null,
    problemItem:'',
    problemExample:''
})
const labelCol = reactive({
      xs: {span: 24},
      sm: {span: 4},
  })
const wrapperCol = reactive({
    xs: {span: 24},
    sm: {span: 20},
})
// const pagination = reactive({
//     current: 1,
//     pageSize: 10,
//     total: 0,
//     showTotal: total => `共 ${total} 条数据`
// })
function searchQuery(){
    setProps({searchInfo:toRaw(actModel)});
    reload()
}
function toQueryByCaNo(caNo){
    selectedRowKeys.value = []
    Object.assign(props.actinfo,{id:'',caNo:'',caName:''})
    actModel.value.caNo = caNo
    searchQuery()
}
defineExpose({toQueryByCaNo})
</script>